﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace AVREmulator
{
    public partial class ScreenMessageViewer : UserControl
    {
        public readonly ScreenBuffer Buffer;
        public readonly bool CommitChanged;

        public ScreenMessageViewer( ScreenBuffer buffer, bool commitChanged )
        {
            InitializeComponent();

            CommitChanged = commitChanged;
            Buffer = buffer;

            if( commitChanged ) {
                label.Text += "\nCommit All Changed Buffers!";
            }

            string rtfColorTable = @"{\colortbl;\red0\green0\blue0;\red0\green0\blue255;\red0\green255\blue255;\red0\green255\blue0;" +
                @"\red255\green0\blue255;\red255\green0\blue0;\red255\green255\blue0;\red255\green255\blue255;" +
                @"\red0\green0\blue128;\red0\green128\blue128;\red0\green128\blue0;\red128\green0\blue128;" +
                @"\red128\green0\blue0;\red128\green128\blue0;\red128\green128\blue128;\red192\green192\blue192;}";
            string rtfFontInit = @"\deff0{\fonttbl{\f0\fnil\fcharset0 Consolas;}}";

            StringBuilder rtfCells = new StringBuilder();
            for( int row = 0 ; row < ScreenBuffer.Height ; row++ ) {
                for( int column = 0 ; column < ScreenBuffer.Width ; column++ ) {
                    ScreenBuffer.Cell cell = buffer.Cells[ column, row ];
                    rtfCells.AppendFormat( @"\cf{0}\cb{1}{2}", cell.FrontColor, cell.BackColor, cell.Character );
                }
                rtfCells.Append(@"\line");
            }

            string rtfCode = @"{\rtf1\ansi" + rtfColorTable + rtfFontInit + rtfCells + "}";
            screenTable.Rtf = rtfCode;
        }
    }
}
