#include <util/delay.h>
#include "config.h"
#include "direct_tests.h"

#ifdef DIRECT_TESTS

void DirectTests_Run(void) {
	while(1) {
		delay_ms( 7000 );

		MSG( "direct test running" );

		MSG( "sending reset..." );

		Buffer_Acquire( FD_SCREEN );
		MSG( "done" );

		delay_ms( 1000 );

		const char data[] = "\tLorem ipsum dolor sit amet, consectetuer sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat...\n\n\tTUM";
#if 0
		MSG( "sending data..." );
		const char data[] = "H_e_l_l_o_ _W_o_r_l_d_!_";
		FPGA_beginData( FD_SCREEN );

		FPGA_setColor( 0, 0 );
		for( int i = 0 ; i < sizeof( data ) - 1 ; i++ ) {
			FPGA_pushChar( data[i] );
		}
		
		MSG( "data sent, waiting to end transmission..." );
		delay_ms( 1000 );
		FPGA_endData();
		MSG( "done" );

		delay_ms( 1000 );
		MSG( "sending commit..." );
		FPGA_sendCommand( FC_COMMIT, FD_TO_FM( FD_SCREEN ) );
		MSG( "done" );
		MSG( "direct test finished" );
#else
		Buffer_WriteEncodedScreenData( (4 << 4) + 7, data, sizeof(data) );

		Buffer_Release();
#endif
	}
}

#endif
