#ifndef _PACKETBUFFER_H_
#define _PACKETBUFFER_H_

// used to transparently either use the uip data buffer or our own for fragmented messages

// to add support for switching services mid-packet
// we need to cache part of the header if necessary
// a valid web header can be bigger, but no one is going to send multiple POSTs one after the other..
// this is just to make sure that the raw headers can be parsed correctly
#define MIN_RAW_PACKET_SIZE 40

char * PacketBuffer_getData(void);
uint16_t PacketBuffer_getLength(void);

void PacketBuffer_pushData( char *data, uint16_t length );
void PacketBuffer_popData( uint16_t length );

void PacketBuffer_makePersistent(void);

void PacketBuffer_init(void);
void PacketBuffer_initConnection(void);

#endif
