#ifndef __INCLUDE_SERIAL_H
#define __INCLUDE_SERIAL_H
#include <avr/io.h>
#include <util/delay.h>
#include <avr/pgmspace.h>
#include <avr/interrupt.h>

void usart_init(uint16_t baud);
uint16_t rx_get(void);
void xputc(uint8_t c);
void xputs(char *s);
void printhex(uint16_t a);
void printhex_l(uint32_t a);
void printhex_sub(uint8_t a);
void printhex8(uint8_t a);

// by AK
#if defined( ENABLE_XPRINTFS ) || defined( ENABLE_LOGSERVICE )
void xprintf( const char *fmt, ... );
void xprintf_P( const char *fmt, ... );
#else
#define xprintf( fmt, ... ) 	(0)
#define xprintf_P( fmt, ... ) 	(0)
#endif

#endif
