#ifndef _WEBCLIENT_H
#define _WEBCLIENT_H

#include "main.h"
#include "app.h"

/* Webclient services (mini HTTP webserver)
Two different services are proffered:
1) connect to the AVR and get the javascript webclient
2) post data from the webclient to the screen

The Get service supports sending the webclient using multiple packets (since it's currently bigger than a single TCP packet)
The Post service decodes the formatted text and sends it to the screen
*/

#define WEBCLIENT_SCREEN_CMD 	"POST "
#define WEBCLIENT_GET_CMD		"GET "
#define WEBCLIENT_POST_REPLY	"HTTP/1.1 303 SEE OTHER\r\nLocation: /\r\n\r\nDone..\r\n"

void WebClient_init(void);

// decodes the data part in the buffer itself
// assert: decoded data length <= encoded data length
// returns the length of the decoded data
uint16_t WebClient_decodeData( unsigned char *data, uint16_t length );

ServiceAnswer WebClient_handlePostPacket( ServiceRequest request, unsigned char *packet, uint16_t length );
ServiceAnswer WebClient_handleGetPacket( ServiceRequest request, unsigned char *packet, uint16_t length );

#endif
